
//     SONS LOCOS #8A
//     Hubert SPERI
//     27/12/2021
//     Modifié : 09/01/2022
//_________________________

//ADUINO UNO ou NANO
//DFPlayer MINI : lecteur de fichier MP3
//_________________________

//Le départ et l'arrêt du cycle sont commandés par infrarouge.
//J'ai utilisé les codes SONY TV des touches numériques.
//J'ai ajouté le code des flèches, POWER, CH+, CH-, Vol+, Vol- et Menu.

//_________________________

//SEQUENCE SONORES
//
//Les séquences sonores que j'ai utilisées durent quelques secondes chacunes.
//_________________________

//ENTREES - SORTIES

//-- capteur infrarouge : entrée «2» ;

//-- Rx de l'ARDUINO : broche «11», reliée à la broche «Tx» du DFPlayer ;
//-- Tx de l'ARDUINO : broche «12», reliée à la broche «Rx» du DFPlayer ;

//Note : dans ce programme, la liason «Rx ARDUINO» vers «Tx DFPlayer» n'est pas utile.

//On n'utilise pas la broche «BUSY» du DFPlayer.

//___________________________________________________________________________



#include <IRremote.h>
#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

SoftwareSerial mySoftwareSerial(11,12); // la broche «11» de l'ARDUINO est utilisée comme «Rx» pour communiquer avec la broche «Tx» du DFPlayer.
                                        // la broche «12» de l'ARDUINO est utilisée comme «Tx» pour communiquer avec la broche «Rx» du DFPlayer.
                                        // Note : la liaison «Rx ARDUINO» --> «Tx DFPlayer» n'est pas utilisée dans ce programme.
                                        
DFRobotDFPlayerMini myDFPlayer;

int IRpin = 2;                          // entrée du capteur IR
IRrecv irrecv(IRpin);
decode_results results;

//int LED_interieure = 9 ;                // jaune
//int LED_four_a_pain = 6 ;               // rouge

//       int Numero_du_son ;                // Modifiées par le programme
//       int Nombre_de_sons ;
//       int Volume ;

int  Touche_9 = 272 ;     // code de démarrage du déroulement du programme ⇒ unités
int  Touche_8 = 3600 ;    // code de démarrage du déroulement du programme ⇒ dizaines
int  Touche_7 = 1552 ;
int  Touche_6 = 2576 ;
int  Touche_5 = 528 ;
int  Touche_4 = 3088 ;
int  Touche_3 = 1040 ;
int  Touche_2 = 2064 ;
int  Touche_1 = 16 ;
int  Touche_0 = 2320 ;
int  Touche_Up = 1904 ;
int  Touche_Down = 3952 ;
int  Touche_Left = 2800 ;
int  Touche_Right = 752 ;
int  Touche_VolUp = 1168 ;
int  Touche_VolDown = 3216 ;
int  Touche_CH_Up = 144 ;
int  Touche_CH_Down = 2192 ;
int  Touche_POWER = 2704 ;
int  Touche_Menu =112 ;
  
//       int Code_valide ; // Modifiées par le programme
       int Premier_chiffre ;
       int Deuxieme_chiffre ;
int OK ;                   // Utilisé comme quittance quand le code à 2 chiffres reçu est celui qui est attendu.

int numero ;               // variable pour choisir un son différent à chaque redémarrage du programme.
                           // Ce n'est pas un nombre aléatoire. Juste différent à chaque fois.
                           // Ce nombre dépend aussi du nombre de faux codes de démarrage (volontaires ou non).


int ON ;
int OFF ;
  
       long Temps_IN ;      // Modifiées par le programme 
       long Temps_OUT ;

       long Temps_initial ;
       long Temps_final ;





//_________________________ CODE DE DEMARRAGE À 2 CHIFFRES ___________________________________________


int Interception_du_code_IR_SONY() 
{
// Codes à 2 chiffres pour cette application :
// -- 30 à 49 ⇒ sélection des sons.

 int Code_valide = !OK ;
  
 while (Code_valide = !OK)
 {   
  // Premier chiffre
      results.value = 0 ;
      while (!(irrecv.decode(&results)))               // Attend indéfiniment (sans rien faire) la réception du premier code.
      { 
      // boucle d'attente
      }
          int Premier_chiffre = results.value ;
          Serial.print("Premier chiffre : ");
          Serial.println(Premier_chiffre);               //Affiche le code reçu.
  
      if (results.value == Touche_3 || results.value == Touche_4)  
            {
            results.value = 999 ;
            delay(300) ;
            irrecv.resume();                           // Receive the next value


 //Deuxième chiffre   
               
            Temps_IN = millis() / 1000 ;
            while (!(irrecv.decode(&results)))         // Attend indéfiniment (sans rien faire) la réception du 2e code.
                  {
                  // boucle d'attente
                  delay(10) ;
                  int Deuxieme_chiffre = results.value ;
                  Temps_OUT = millis() / 1000 ;
                  if ((Temps_OUT - Temps_IN) > 2)       // Si aucun 2e code détecté avant 2 secondes, on quitte la boucle «while»
                      {
                      results.value = 999 ;             // ... en imposant un code non valide.
                      Serial.println("Dépassement du temps d'attente");
                      Code_valide = !OK ;
                      delay(100) ;
                      irrecv.resume();
                      break ;
                      }
                  if (results.value > 5000)
                      {
                      Code_valide = !OK ;
                      Serial.println("Code incorrect");
                      irrecv.resume();
                      delay(100) ;
                      break ; 
                      }   
                  }                         
            int resultat[] = {Premier_chiffre , Deuxieme_chiffre} ;
            Serial.println(Premier_chiffre) ;
            Serial.println(Deuxieme_chiffre) ;
            Serial.println(resultat[0]) ;
            Serial.println(resultat[1]) ;
            return resultat ;            
        }
        delay(1000) ;    // Delai avant une 2e tentative.
    }   
}   



//_________________________ DECODAGE DE LA SAISIE ___________________________________________


int Numero_du_son()
   {
    int Numero ;
    int Premier_chiffre = 1 ;
    int Deuxieme_chiffre = 2 ;
    
    int Resultat_decodage[] = {Premier_chiffre , Deuxieme_chiffre} ;
  //  Resultat_decodage[1] ;
    
    Resultat_decodage[0] = Interception_du_code_IR_SONY() ;
    Resultat_decodage[1] = Interception_du_code_IR_SONY() ;
    
     Premier_chiffre = Resultat_decodage[0] ;
     Deuxieme_chiffre = Resultat_decodage[1] ;

    Serial.print("Premier chiffre décodé = ") ;
    Serial.println(Premier_chiffre) ;
    Serial.print("Deuxième chiffre décodé = ") ;
    Serial.println(Deuxieme_chiffre) ;
    
   // Décade 3 -------------------------------------- 
   if (Premier_chiffre == Touche_3) 
     {
        if (Deuxieme_chiffre == Touche_0)          {Numero = 10 ; }     
        if (Deuxieme_chiffre == Touche_1)          {Numero = 1 ; }  
        if (Deuxieme_chiffre == Touche_2)          {Numero = 2 ; }        
        if (Deuxieme_chiffre == Touche_3)          {Numero = 3 ; }        
        if (Deuxieme_chiffre == Touche_4)          {Numero = 4 ; }        
        if (Deuxieme_chiffre == Touche_5)          {Numero = 5 ; }             
        if (Deuxieme_chiffre == Touche_6)          {Numero = 6 ; }     
        if (Deuxieme_chiffre == Touche_7)          {Numero = 7 ; }     
        if (Deuxieme_chiffre == Touche_8)          {Numero = 8 ; }        
        if (Deuxieme_chiffre == Touche_9)          {Numero = 9 ; } 
      }  


      // Décade 4 --------------------------------------
      if (Premier_chiffre == Touche_4) 
      {
        if (Deuxieme_chiffre == Touche_0)          {Numero = 20 ; }     
        if (Deuxieme_chiffre == Touche_1)          {Numero = 11 ; }     
        if (Deuxieme_chiffre == Touche_2)          {Numero = 12 ; }       
        if (Deuxieme_chiffre == Touche_3)          {Numero = 13 ; }         
        if (Deuxieme_chiffre == Touche_4)          {Numero = 14 ; }        
        if (Deuxieme_chiffre == Touche_5)          {Numero = 15 ; }             
        if (Deuxieme_chiffre == Touche_6)          {Numero = 16 ; }     
        if (Deuxieme_chiffre == Touche_7)          {Numero = 17 ; }     
        if (Deuxieme_chiffre == Touche_8)          {Numero = 18 ; }       
        if (Deuxieme_chiffre == Touche_9)          {Numero = 19 ; } 
      } 
      Serial.println() ;
      Serial.print("Numero du son = ") ;
      Serial.println(Numero) ;
      return Numero ;
   }




//___________________________ SETUP _________________________________________


void setup() 
  {
  irrecv.enableIRIn();

  pinMode(6, OUTPUT);                     // LED rouge ...
  pinMode(9, OUTPUT);                     // et LED jaune du foyer

  mySoftwareSerial.begin(9600);           // pour communiquer avec le DFPlayer
  myDFPlayer.begin(mySoftwareSerial);
  
 // myDFPlayer.volume(0);

  //  ----EQUALIZER : PARAMETRAGES POSSIBLES
  //  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  //  myDFPlayer.EQ(DFPLAYER_EQ_POP);
  //  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
  myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);
  //  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
  //  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
 
  Serial.begin(9600);                     // Pour communiquer avec le moniteur
  pinMode(13, OUTPUT);                    // LED de contrôle de la réception d'un code.

  int Nombre_de_sons = myDFPlayer.readFileCounts() ;                    // C'est le nombre de séquences sonores enregistrées sur la carte «T».

  }


//__________________________________ VOID LOOP __________________________________


void loop() 
  { 
  Serial.println("-------------------------") ;
  Serial.println("Attente du code démarrage") ;  // monitoring de contrôle. Peut être supprimée.

  const int Volume = 10 ;
  myDFPlayer.volume(Volume);
   
  irrecv.resume();   // Receive the next value  
    
  myDFPlayer.play(Numero_du_son() );     
     
  }
